      subroutine  candpl(n,a,b,dffact,nelt,maxelt,aelt,belt,
     +                 celt,objb,objw,indb,indw,obj,
     +                 elitex,iter,iterb,ittype)
      implicit none
c     ------------------------------------------------------------------
c     candpl:  Verify if solution a,b should be inserted in the pool.
c     ------------------------------------------------------------------
c     Passed scalars:
c     
c     n      - problem dimension
c     dffact - differentiation factor between a candidate solution
c                 and all solutions in the pool
c     nelt   - number of elite solutions in the pool
c     maxelt - maximum number of elite solutions in the pool
c     objb   - cost of the best solution in the pool
c     objw   - cost of the worst solution in the pool
c     obj    - cost of the candidate solution 
c     indb   - position of the best solution in the pool
c     indw   - position of the worst solution in the pool
c     iterb  - iteration that found the  best solution 
c     iter   - number of GRASP iterations taken
c     elitex - flag that indicates if the pool of elite has changed
c     ittype - type of iteration summary: = 0, silent
c                                         = 1, print improving solutions
c                                         = 2, print all iterations
c
c     ------------------------------------------------------------------
      integer n,nelt,maxelt,ittype
      integer objb,objw,obj,indb,indw,iter,iterb
      real*4  dffact
      logical elitex
c     ------------------------------------------------------------------
c     Passed arrays:
c
c     a     - permutation array
c     b     - permutation array
c     aelt  - a permutation arrays in the pool of elite solutions
c     belt  - b permutation arrays in the pool of elite solutions
c     celt  - array of costs of elite solutions
c     ------------------------------------------------------------------
      integer a(n), b(n)
      integer aelt(n*maxelt),belt(n*maxelt),celt(maxelt)
c     ------------------------------------------------------------------
c     Local scalars:
c
c     isdif  - indicates if permutation a,b is different from
c               all permutations in the pool
c     diffpl - function to verify if permutation a,b is different from
c               all permutations in the pool
c     ------------------------------------------------------------------
      logical isdif, diffpl
c     ------------------------------------------------------------------
      
      if (obj.lt.objb) then
          call insrpl(n,a,b,nelt,maxelt,aelt,belt,
     +              celt,objb,objw,indb,indw,obj)
          elitex = .true.
          iterb  = iter

          if ((ittype.eq.1).or.(ittype.eq.2)) then
               print *, 'pathrl: ** improvement** objb= ', objb
               call myflsh
          endif
      else
         if (obj.lt.objw) then
             isdif = diffpl(n,a,b,dffact,nelt,maxelt,aelt,belt)
             if (isdif) then
                 call insrpl(n,a,b,nelt,maxelt,aelt,belt,
     +              celt,objb,objw,indb,indw,obj)
                 elitex = .true.
             endif
         endif
      endif
  

      return
      end

  
