      subroutine costdf(n,n3,a,b,i,j,lower,c,anotb,gain)
      implicit none
c     ------------------------------------------------------------------
c     costdf: evaluates the difference between the solution
c     and the new solution suggested by the 2-exchange of i and j.
c     Returns the logical lower and the gain. 
c     ------------------------------------------------------------------
c     Passed scalars:
c     
c     n      - problem dimension
c     n3     - n * n * n
c     i      - 2-exchange index
c     j      - 2-exchange index
c     lower  - objective function improvement
c     anotb  - tells which permutation is updated 
c              if anotb=true then a is regarded
c              if anotb=false then b is regarded
c     gain   - gain from switch
c     
c     ------------------------------------------------------------------
      integer n,n3,i,j,gain
      logical lower,anotb
c     ------------------------------------------------------------------
c     Passed arrays:
c     
c     c      - cost matrix
c     a      - permutation array
c     b      - permutation array
c     
c     ------------------------------------------------------------------     
      integer a(n),b(n),c(n3)
c     ------------------------------------------------------------------
c     Compute the gain from the switch.(Old solution-new solution)
c     If anotb then permutation a is changed, else b.
c     ------------------------------------------------------------------
c     index=n*n*(i-1)+n*(j-1)+k

      if (anotb) then
         gain=c(n*n*(i-1)+n*(a(i)-1)+b(i))+c(n*n*(j-1)+n*(a(j)-1)+b(j))
     +        -c(n*n*(i-1)+n*(a(j)-1)+b(i))-c(n*n*(j-1)+n*(a(i)-1)+b(j)) 
      else
         gain=c(n*n*(i-1)+n*(a(i)-1)+b(i))+c(n*n*(j-1)+n*(a(j)-1)+b(j))
     +        -c(n*n*(i-1)+n*(a(i)-1)+b(j))-c(n*n*(j-1)+n*(a(j)-1)+b(i))
      end if
      
c     ------------------------------------------------------------------
c     if the gain is positive,i.e. the new solution is better,
c     return lower as true, else as false.
c     ------------------------------------------------------------------
      if (gain.gt.0) then
         lower=.true.
      else
         lower=.false.
      end if
      return
      end



