       subroutine debcost (maxelt,nelt,n,n3,c,a,b,obj,aelt,belt,celt,
     +                     seedit,iter)

      implicit none
c     ------------------------------------------------------------------
c     debcost: debug cost.  
c     ------------------------------------------------------------------
c     Passed arrays and scalars:
c
c     c     - cost matrix
c     a     - permutation array
c     b     - permutation array
c     n     - problem dimension
c     n3    - n*n*n
c     obj   - cost of solution a,b
c     aelt  - a permutations array in the pool of elite solutions
c     belt  - b permutations array in the pool of elite solutions
c     celt  - array of elite solution costs
c     iter  - current iteration number
c     seedit - seed that starts current iteration
c
c     ------------------------------------------------------------------
      integer n,n3,obj,maxelt,nelt
      integer a(n),b(n),c(n3)
      integer aelt(n*maxelt),belt(n*maxelt),celt(n*maxelt)
      integer seedit,iter 
c     ------------------------------------------------------------------
c     Local scalars:
c
c     cost 
c
c     ------------------------------------------------------------------
      integer cost,i,j,offset
      logical error
c     ------------------------------------------------------------------
c     index=n*n*(i-1)+n*(j-1)+k

       cost = 0
       error = .false.
 
       do 10 i=1,n    
         cost = cost + c(n*n*(i-1)+n*(a(i)-1)+b(i))
10     continue

       if (cost.ne.obj) then
         print *, 'Erro! custo=',obj,'correto=',cost,
     +            'iter',iter,'seedit',seedit
         error = .true.
       endif

       do 30 j=1,nelt 
         cost = 0  
         offset = n*(j-1)
         do 20 i=1,n         
           cost = cost + c(n*n*(i-1)+n*(aelt(i+offset)-1)+
     +               belt(i+offset))
20       continue

         if (cost.ne.celt(j)) then
           print *, 'Erro no pool! custo=',celt(j),
     +           'correto=',cost,
     +            'iter',iter,'seedit',seedit,
     +            'pos',j
            error = .true.
         endif
30     continue 
     

       if (error) then
c           print *, 'Pool A:'
c           print *, (aelt(i),i=1,n*maxelt)
c           print *, 'Pool B:'
c           print *, (belt(i),i=1,n*maxelt)
c           print *, 'Costs:'
c           print *, (celt(i),i=1,maxelt)      
        stop
       endif

       return
       end
