      program driver
c     -----------------------------------------------------------------
c     Fortran driver for subroutine g3aps (GRASP and path relinking 
c     for the AP3).
c     ------------------------------------------------------------------
c     Parameters, variables and arrays needed for the         
c     subroutine g3aps.
c     ------------------------------------------------------------------
      integer   maxn,maxn3
      parameter (maxn=66,maxn3=maxn*maxn*maxn)      
      integer   infty
      parameter (infty=2147483647)
      integer   seedg,seedp,iter,maxitr,look4
      integer   a(maxn),b(maxn)
      integer   c(maxn3),srtc(maxn3),srtic(maxn3)
      integer   n,n3
      real*4    cput(2),bcpu,etime,totcpu,dffact
      integer   nelt,maxelt,prfrq
      parameter (maxelt=30)
c      parameter (prfrq=25000) 
   
      integer   aelt(maxn*maxelt),belt(maxn*maxelt),celt(maxelt)
      integer   objb,objw,indb,indw,iterb
      integer  apool(maxn),bpool(maxn)
      integer  stora(maxn),storb(maxn) 
      integer adiff(maxn),aprev(maxn),anext(maxn),alist(maxn)
      integer bdiff(maxn),bprev(maxn),bnext(maxn),blist(maxn) 
      integer backa(maxn),backb(maxn),backobj
      
      integer srnext(maxn3),srprev(maxn3)
      integer iprev(maxn),jprev(maxn),kprev(maxn)
      integer inext(maxn),jnext(maxn),knext(maxn)
      integer posind(maxn3)

c     ------------------------------------------------------------------
c     Parameters, variables and arrays needed by the driver
c     trand  - indicates if target solution is obtained randomly
c     trgtpl - indicates if path relinking is to be done torward 
c              a solution in the pool 
c     trgtgp - indicates if path relinking is to be done torward 
c              the solution obtained by the last GRASP iteration
c     all    - indicates if path relinking will be applied to all
c              elite solutions
c     ittype - type of iteration summary: = 0, silent
c                                         = 1, print improving solutions
c                                         = 2, print all iterations
c     ------------------------------------------------------------------
      integer in,out,iseedg,iseedp,ittype
      logical change
      parameter (in=5,out=6)
      logical   trand,trgtpl,trgtgp,all,dopath,dopost
c     ------------------------------------------------------------------
      real    randp,xrand
      integer i

#ifdef READ_DATA
      read(in,*) seedg
      read(in,*) maxitr
      read(in,*) look4
      read(in,*) trand
      read(in,*) dopath
      read(in,*) dopost
      read(in,*) prfrq

      print *, 'reading data from file'
      print *, 'look4:',look4
      print *, 'trand:',trand
      print *, 'dopath:',dopath
      print *, 'prfrq:',prfrq
#else
      print *, 'data set in the program'
      seedg  = 270001
      maxitr = 100
      look4  = -1
      trand  = .false. 
      dopath = .true.
      dopost = .true.
      prfrq  = 25000
#endif
      
    
      iseedg=seedg
      seedp=270002
      iseedp=seedp
 
      bcpu=etime(cput)
      dffact = 0.5


      trgtpl = .true.
      trgtgp = .true.
      all    = .not.trand
      ittype = 1

      call readc(in,n,maxn,maxn3,c)

c      do 5 i=1,7
c         xrand=randp(seedg)
c5     continue
c      iseedg=seedg

      call g3aps(in,n,n3,maxn3,maxn,infty,seedg,seedp,iter,maxitr,
     +           look4,c,nelt,maxelt,aelt,belt,celt,     
     +           objb,objw,indb,indw,iterb,dffact,prfrq,
     +           trand,trgtpl,trgtgp,all,dopath,ittype,
     +           apool,bpool,stora,storb,
     +           adiff,bdiff,aprev,bprev,anext,bnext,
     +           alist,blist,backa,backb,backobj,srtc,srtic,
     +           a,b,srnext,srprev,
     +           iprev,jprev,kprev,inext,jnext,knext,posind)
  
c      print *, 'sai de g3aps. nelt =',nelt
c      call myflsh

      change = .true.
10    if (change.and.dopost.and.dopath) then
           call psopt (n,n3,seedp,dffact,c,nelt,maxelt,
     +            aelt,belt,celt,objb,objw,
     +            indb,indw,iter,iterb,ittype,
     +            adiff,bdiff,aprev,bprev,anext,bnext,
     +            alist,blist,backa,backb,backobj)  
 
c            print *, 'sai de posopt'
c            call myflsh

           call pslcl  (n,n3,dffact,c,nelt,maxelt,aelt,belt,
     +            celt,objb,objw,indb,indw,change,iter,
     +            iterb,ittype) 

c           print *, 'sai de pslcl'
c           call myflsh

           goto 10
       endif    

      

      totcpu=etime(cput)-bcpu

c     ------------------------------------------------------------------
c     Write output summary.
c     ------------------------------------------------------------------

      call outsol(out,n,n3,iter,iterb,iseedg,iseedp,celt,aelt,belt,indb)

      
      print *,'Total cpu-time: ',totcpu
      
      stop
      end








