      logical function fndlst(n,index,pos,plist,pprev,
     +                                 pnext,pfirst,plast)
      implicit none
c     ------------------------------------------------------------------
c     fndlst: Finds index in the linked list.
c     ------------------------------------------------------------------
c     Passed scalars:
c     
c     n      - problem dimension
c     pfirst - first element in the linked list of differences
c     plast  - last  element in the linked list of differences
c     index  - index of element to be found
c     pos    - index of found element in the list of moves 
c     ------------------------------------------------------------------
      integer n,pfirst,plast,index,pos
c     ------------------------------------------------------------------
c     Passed arrays:
c
c     pprev  - pointers to previous elements in the differences list 
c     pnext  - pointers to next elements in the differences list 
c     plist  - list of moves
c     ------------------------------------------------------------------
      integer pprev(n),pnext(n),plist(n)
c     ------------------------------------------------------------------
c     Local scalars:
c     
c     pointer - pointer to element of the list of moves 
c     found   - indicates if element was found in the list of moves
c     ------------------------------------------------------------------
      integer pointer
      logical found
c     ------------------------------------------------------------------    
     
      pointer = pfirst
      found = .false.

10    if(pointer.ne.0) then
        if (plist(pointer).eq.index) then
            pos   = pointer
            found = .true.
            goto 20
        endif  
        pointer = pnext(pointer)
        goto 10
      endif

20    fndlst = found 
      return
      end
