      subroutine getrgt(n,maxelt,npool,aelt,belt,celt,
     +                   apool,bpool,cpool)
      implicit none

c     ------------------------------------------------------------------
c     getrgt: Copy target solutions into auxiliary arrays.
c     ------------------------------------------------------------------
c     Passed scalars:
c     
c     n      - problem dimension
c     maxelt - maximum number of elite solutions in the pool
c     npool  - index of target permutation in the pool
c     cpool  - object function value of chosen pool solution
c
c     ------------------------------------------------------------------
      integer n, npool,maxelt,cpool
c     ------------------------------------------------------------------
c     Passed arrays:
c     
c     aelt  - a permutations array in the pool of elite solutions
c     belt  - b permutations array in the pool of elite solutions
c     celt  - array of elite solution costs
c     apool - array of target permutation a in the pool
c     bpool - array of target permutation b in the pool
c     
c     ------------------------------------------------------------------
      integer aelt(n*maxelt),belt(n*maxelt),celt(n*maxelt)
      integer apool(n),bpool(n)
c     ------------------------------------------------------------------
c     Local scalars:
c     i      - loop counter
c     offset - beginning of target permutation in the pool
c     ------------------------------------------------------------------
      integer  i, offset
c     ------------------------------------------------------------------
      offset = (npool-1)*n 
      do 10 i=1,n
         apool(i)= aelt(offset+i)
         bpool(i)= belt(offset+i)
10    continue
      
      cpool = celt(npool)
      return
      end
