      subroutine insrpl(n,a,b,nelt,maxelt,aelt,belt,
     +                    celt,objb,objw,indb,indw,obj)
      implicit none
c     ------------------------------------------------------------------
c     insrpl: Inserts solution a,b in the pool.  If the pool is full,
c     the worst solution is eliminated.
c     ------------------------------------------------------------------
c     Passed scalars:
c     
c     n      - problem dimension
c     nelt   - number of elite solutions in the pool
c     maxelt - maximum number of elite solutions in the pool
c     objb   - cost of the best solution in the pool
c     objw   - cost of the worst solution in the pool
c     obj    - cost of the candidate solution 
c     indb   - position of the best solution in the pool
c     indw   - position of the worst solution in the pool
c     ------------------------------------------------------------------
      integer n,nelt,maxelt
      integer objb,objw,obj,indb,indw
c     ------------------------------------------------------------------
c     Passed arrays:
c
c     a     - permutation array
c     b     - permutation array
c     aelt  - a permutation arrays in the pool of elite solutions
c     belt  - b permutation arrays in the pool of elite solutions
c     celt  - array of elite solutions costs
c     ------------------------------------------------------------------
      integer a(n), b(n)
      integer aelt(n*maxelt),belt(n*maxelt),celt(maxelt)
c     ------------------------------------------------------------------
c     Local scalars:
c     i      - loop index
c     offset - beginning of new arrays in the pool
c     pos    - position where new solution will be inserted
c     ------------------------------------------------------------------
      integer i,offset,pos
c     ------------------------------------------------------------------

       if (nelt.lt.maxelt)  then
          nelt = nelt +1
          pos = nelt
          celt(pos) = obj
          
          if (obj.gt.objw) then
             objw = obj
             indw = pos
          endif
       else
          pos = indw
          celt(pos) = obj

          objw = - 2147483647
          do 10 i=1, nelt
             if (celt(i).gt.objw) then
                objw = celt(i)
                indw = i
             endif
10        continue
       endif

       if (obj.lt.objb) then
          objb     = obj
          indb     = pos
       endif

      
c     ------------------------------------------------------------------
c      Write new solution to the pool.
c     ------------------------------------------------------------------
      
      offset = (pos-1)*n
      do 20 i=1, n
         aelt(offset+i) = a(i)
         belt(offset+i) = b(i) 
20    continue
    
      return
      end





