      subroutine insrtq(n3,v,iv,sizeq,q,iq)
      implicit none

c     ------------------------------------------------------------------
c     insrtq: Insert an element (v,iv) into a queue (q,iq).
c     ------------------------------------------------------------------
c     Passed scalars:
c     
c     n3     - n * n * n
c     v      - heap element (value)
c     iv     - heap element (index)
c     sizeq  - size of heap
c     
c     ------------------------------------------------------------------
      integer n3,sizeq,iv,v
c     ------------------------------------------------------------------
c     Passed arrays:
c     
c     q      - heap (value)
c     iq     - heap (index)
c     
c     ------------------------------------------------------------------
      integer iq(n3),q(n3)
c     ------------------------------------------------------------------
c     Local scalars:
c     
c     sq     - temporary size of heap
c     tsz    - temporary variable (sq/2)
c     w      - temporary variable
c     iw     - temporary variable
c     
c     ------------------------------------------------------------------
      integer sq,tsz,w,iw
      
c     ------------------------------------------------------------------
c     Insert element into heap.
c     ------------------------------------------------------------------
      sizeq=sizeq+1
      q(sizeq)=v
      iq(sizeq)=iv
c     ------------------------------------------------------------------
c     Update heap to proper order.
c     ------------------------------------------------------------------
      sq=sizeq
      w=q(sq)
      iw=iq(sq)
 10   tsz=sq/2
      if (tsz.ne.0) then
         if (q(tsz).ge.v) then
            q(sq)=q(sq/2)
            iq(sq)=iq(sq/2)
            sq=sq/2
            goto 10
         endif
      endif
      q(sq)=w
      iq(sq)=iw
      return
      end
