      subroutine insrpl(n,a,b,nelite,maxelite,aelite,belite,
     +                    celite,objbest,objworst,indbest,indworst,obj)
      implicit none
c     ------------------------------------------------------------------
c     insrtpool: insert solution a,b in the pool.  If the pool is full,
c     the worst solution is eliminated.
c     ------------------------------------------------------------------
c     Passed scalars:
c     
c     n        - problem dimension
c     nelite   - number of elite solutions in the pool
c     maxelite - maximum number of elite solutions in the pool
c     objbest  - cost of the best solution in the pool
c     objworst - cost of the worst solution in the pool
c     obj      - cost of the candidate solution 
c     indbest  - position of the best solution in the pool
c     indworst - position of the worst solution in the pool
c     ------------------------------------------------------------------
      integer n,nelite,maxelite
      integer objbest,objworst,obj,indbest,indworst
c     ------------------------------------------------------------------
c     Passed arrays:
c
c     a      - permutation array
c     b      - permutation array
c     aelite - a permutation arrays in the pool of elite solutions
c     belite - b permutation arrays in the pool of elite solutions
c     celite - array of elite solutions costs
c     ------------------------------------------------------------------
      integer a(n), b(n)
      integer aelite(n*maxelite), belite(n*maxelite), celite(maxelite)
c     ------------------------------------------------------------------
c     Local scalars:
c     i        - loop index
c     offset   - beginning of new arrays in the pool
c     pos      - position where new solution will be inserted
c     ------------------------------------------------------------------
      integer i,offset,pos
c     ------------------------------------------------------------------

       if (nelite.lt.maxelite)  then
          nelite = nelite +1
          pos = nelite
          c(pos) = obj
          
          if (obj.gt.objworst) then
             objworst = obj
             indworst = pos
          endif
       else
          pos = indworst
          c(pos) = obj

          objworst = - 2147483647
          do 10 i=1, nelite
             if (celite(i).gt.objworst) then
                objworst = celite(i)
                indworst = i
             endif
10        continue
       endif

       if (obj.lt.objbest) then
          objbest     = obj
          indbest     = pos
       endif


      
c     ------------------------------------------------------------------
      Write new solution to the pool
c     ------------------------------------------------------------------
      
      offset = (pos-1)*n
      do 20 i=1, n
         aelite(offset+i) = a(i)
         belite(offset+i) = b(i) 
20    continue
    
      return
      end





