      subroutine outsol(out,n,n3,iter,iterb,iseedg,iseedp,
     +                   celt,aelt,belt,indb)
      implicit none
c     ------------------------------------------------------------------
c     Output best solution found and run statistics.
c     ------------------------------------------------------------------
c     Passed scalars:
c
c     out    - output unit
c     n      - 3AP dimension
c     n3     - n*n*n
c     iter   - number of GRASP iterations taken
c     iterb  - iteration that found the  best solution 
c     iseedg - initial seed for GRASP
c     iseedp - initial seed for path relinking
c     indb   - index of best assignment in the pool
c
c     ------------------------------------------------------------------
      integer out,n,n3,iter,iterb,iseedg,iseedp,indb
c     ------------------------------------------------------------------
c     Passed arrays:
c
c     
c     aelt    - a permutations array in the pool of elite solutions
c     belt    - b permutations array in the pool of elite solutions
c     celt    - array of elite solution costs 
c   
c     ------------------------------------------------------------------
      integer celt(n),aelt(n),belt(n)
c     -------------------------------------------------------------
c      Local scalar:
c
c      i      - loop index
c     -------------------------------------------------------------
      integer i
c     ------------------------------------------------------------------
      write(out,10)
 10   format(
     +     '----------------------------------------------------------')
      write(out,20)
 20   format(
     +     'G R A S P for 3AP-----------------------------------------')
      write(out,30)
 30   format('                                       ')
      
      write(out,40)
 40   format(
     +     'input-----------------------------------------------------')
      write(out,50) n
 50   format(' dimension of 3ap                   : ',i20)
      
      write(out,80) iseedg
 80   format(' initial seed for GRASP             : ',i20)

      write(out,90) iseedp
 90   format(' initial seed for path relinking    : ',i20)
      
      write(out,30)
      write(out,100)
 100   format(
     +     'output----------------------------------------------------')

      write(out,140) iter
 140  format(' grasp iterations                   : ',i20)
 
      write(out,145) iterb
 145  format(' grasp best iteration               : ',i20)

      write(out,150) celt(indb)
 150  format(' cost of best permutations found    : ',i20)
      write(out,160) (aelt((indb-1)*n+i),i=1,n)
 160  format(' best permutation a found           : ',
     &     5i4,/,(36x,': ',5i4))
      write(out,170) (belt((indb-1)*n+i),i=1,n)
 170  format(' best permutation b found           : ',
     &     5i4,/,(36x,': ',5i4))
      write(out,30)
      write(out,10)
      return
      end       
