      subroutine qcksrt(n,arr,index)
c     ------------------------------------------------------------------
c     Quichsort subroutine from Numerical Recipes by Press et al 
c     (pp 236-7).
c     Sorts array arr of size n in ascending order.
c     ------------------------------------------------------------------
      integer m,nstack
      real  fm,fa,fc,fmi
      parameter(m=7,nstack=100000,fm=7875.,fa=211.,fc=1663.,fmi=1./fm)

c     ------------------------------------------------------------------
      integer n,index(n),istack(nstack)
      integer arr(n)
c     ------------------------------------------------------------------
      integer  jstack,l,ir,i,j,ia,iq
      integer a
      real   fx
c     ------------------------------------------------------------------
      jstack=0
      l=1  
      ir=n
      fx=0.
10    if(ir-l.lt.m)then
          do 13 j=l+1,ir
                a=arr(j)
                ia=index(j)
                do 11 i=j-1,1,-1
                     if(arr(i).le.a)goto 12
                     arr(i+1)=arr(i)
                     index(i+1)=index(i) 
11              continue
                i=0
12              arr(i+1)=a
                index(i+1)=ia
13        continue
          if(jstack.eq.0)return
          ir=istack(jstack)
          l=istack(jstack-1)
          jstack=jstack-2
      else
          i=l
          j=ir
          fx=mod(fx*fa+fc,fm)
          iq=l+(ir-l+1)*(fx*fmi)
          a=arr(iq)
          ia=index(iq)
          arr(iq)=arr(l)
          index(iq)=index(l)
20        continue
21            if(j.gt.0)then
                   if(a.lt.arr(j))then
                        j=j-1
                        goto 21
                   endif
              endif
              if(j.le.i)then
                   arr(i)=a
                   index(i)=ia
                   goto 30
              endif
              arr(i)=arr(j)
              index(i)=index(j)
              i=i+1
22            if(l.le.n)then
                   if(a.gt.arr(i))then
                        i=i+1
                        goto 22
                   endif
              endif
              if(j.le.i)then
                   arr(j)=a
                   index(j)=ia
                   i=j
                   goto 30
              endif
              arr(j)=arr(i)
              index(j)=index(i)
              j=j-1
          goto 20
30        jstack=jstack+2
          if(ir-i.ge.i-l)then
               istack(jstack)=ir
               istack(jstack-1)=i+1
               ir=i-1
          else
               istack(jstack)=i-1
               istack(jstack-1)=l
               l=i+1
          endif
      endif
      goto 10  
      end
