      subroutine readc(in,n,maxn,maxn3,c)
      implicit none
 
c     -------------------------------------------------------------
c     readc: Reads the cost matrix and stores it in a
c     one-dimensional array. The format of the infile is
c     as follows:
c     -------------------------------------------------------------
c     Passed scalar:
c     
c     n     - 3ap dimension
c     maxn  - maximum 3ap dimension
c     in    - output unit
c     maxn3 - maxn*maxn*maxn
c     -------------------------------------------------------------
      integer in,n,maxn3,maxn,ncube
c     -------------------------------------------------------------
c     Passed arrays:
c       
c     c     - cost matrix stored as a one-dimensional array.
c     -------------------------------------------------------------
      integer c(maxn3)
c     -------------------------------------------------------------
c     Local scalars:
c     
c     i    - row number
c     j    - column number
c     k    - loop counter
c     tmp  - dummy variable
c     cijk - cost matrix element with indices i,j,k
c     -------------------------------------------------------------
      integer i,j,k,cijk
      character tmp
c     -------------------------------------------------------------
c     Read prob dim
c     -------------------------------------------------------------
      read(in,*) n
c     -------------------------------------------------------------
c     check if dimension is ok
c     -------------------------------------------------------------
      if (n .gt. maxn) then
	print *,'error: increase maxn to ',n
	stop
      endif
c     -------------------------------------------------------------
c     Cost matrix is stored as a one-dimensional array with the
c     formula: index=n*n*(i-1)+n*(j-1)+k
c     -------------------------------------------------------------
      ncube=n*n*n
      do 10 i=1,ncube
            read(in,*) c(i)
 10   continue
      
      return 
      end
