      subroutine removq(n3,v,iv,sizeq,q,iq)

      implicit none
c     ------------------------------------------------------------------
c     removq: Remove smallest element (v,iv) from a priority 
c             queue (q,iq).
c     ------------------------------------------------------------------
c     Passed scalars:
c
c     n3     - n * n * n
c     v      - smallest element in heap (value)
c     iv     - smallest element in heap (index)
c     sizeq  - size of heap
c
c     ------------------------------------------------------------------
      integer n3,v,iv,sizeq
c     ------------------------------------------------------------------
c     Passed arrays:
c
c     q      - heap (value)
c     iq     - heap (index)
c
c     ------------------------------------------------------------------
      integer iq(n3),q(n3)
c     ------------------------------------------------------------------
c     Local scalars:
c
c     vtmp   - tmp smallest element in heap (value)
c     ivtmp  - tmp smallest element in heap (index)
c     k      - heap counter
c     j      - heap counter (2*k)
c     szqd2  - sizeq/2
c
c     ------------------------------------------------------------------
      integer vtmp,ivtmp,k,j,szqd2
c     ------------------------------------------------------------------
c     Remove element from heap.
c     ------------------------------------------------------------------
      v=q(1)
      iv=iq(1)
      q(1)=q(sizeq)
      iq(1)=iq(sizeq)
      sizeq=sizeq-1
c     ------------------------------------------------------------------
c     Update heap to proper order.
c     ------------------------------------------------------------------
      k=1
      vtmp=q(k)
      ivtmp=iq(k)
      szqd2=sizeq/2
10    if (k .gt. szqd2) goto 20
	   j=k+k
	   if (j .lt. sizeq) then
		if (q(j) .gt. q(j+1)) j=j+1
	   endif
	   if (vtmp .le. q(j)) goto 20
	   q(k)=q(j)
	   iq(k)=iq(j)
	   k=j
	   goto 10
20    continue
      q(k)=vtmp
      iq(k)=ivtmp
      return
      end
