      subroutine rmvsd(n,index,pprev,pnext,pfirst,plast)
      implicit none
c     ------------------------------------------------------------------
c     rmvsymdif: Removes index from linked list.
c     ------------------------------------------------------------------
c     Passed scalars:
c     
c     n      - problem dimension
c     pfirst - first element in the linked list of differences
c     plast  - last  element in the linked list of differences
c     index  - index of element to be removed
c     ------------------------------------------------------------------
      integer n,pfirst,plast,index
c     ------------------------------------------------------------------
c     Passed arrays:
c
c     pprev  - pointers to previous elements in the differences list 
c     pnext      - pointers to next elements in the differences list 
c     ------------------------------------------------------------------
      integer pprev(n),pnext(n)
c     ------------------------------------------------------------------

      if ((index.ne.pfirst).and.(index.ne.plast)) then
         pnext(pprev(index)) =  pnext(index)
         pprev(pnext(index)) =  pprev(index)
         goto 10
      endif

      if (index.eq.pfirst) then
          pfirst = pnext(pfirst)
          if (pfirst.ne.0) pprev(pfirst) = 0
      endif

      if (index.eq.plast) then
          plast = pprev(plast)
          if (plast.ne.0) pnext(plast) = 0
      endif
     
10    return
      end
