      integer function sd(n,p,ptrgt,pdiff,pprev,pnext,plist,
     +                    pfirst,plast)
      implicit none
c     ------------------------------------------------------------------
c     sd (simetric difference): Returns in  pdiff(i) the position
c     where p(i) should be moved to turn p into the target permutation.
c     Returns the distance between p and the target permutation, i.e, 
c     the number of elements in p that are in the wrong position  
c     according to the target permutation.
c     ------------------------------------------------------------------
c     Passed scalars:
c     
c     n       - problem dimension
c     pfirst  - first element in the linked list of differences
c     plast   - last  element in the linked list of differences
c     ------------------------------------------------------------------
      integer n,pfirst,plast
c     ------------------------------------------------------------------
c     Passed arrays:
c
c     p       - permutation array
c     ptrgt   - p target solution
c     pdiff   - array of p symetric differences
c     pprev   - pointer to previous elements in the list of differences
c     pnext   - pointer to next elements in the list of differences
c     plist   - linked list of differences
c     ------------------------------------------------------------------
      integer p(n),ptrgt(n),pdiff(n)
      integer pprev(n),pnext(n),plist(n)
c     ------------------------------------------------------------------
c     Local scalars:
c     i       - loop index
c     j       - loop index
c     delta   - distance between target permutation and p
c     ------------------------------------------------------------------
      integer i,j
      integer delta
c     ------------------------------------------------------------------
      delta = 0

      do 20 i=1,n
         if (p(i).ne.ptrgt(i)) then
            do 10 j=1,n
                if (p(i).eq.ptrgt(j)) then
                   pdiff(i) = j 
                   delta = delta +1
                   plist(delta) = i
                   goto 10
                endif
 10         continue
         else  
            pdiff(i) = i
         endif
 20   continue
 

      do 30 i=1, delta
        pnext(i) = i+1
        pprev(i) = i-1
 30   continue

      if (delta.gt.0) then
           pfirst = 1
           pnext(delta) = 0
      else
           pfirst = 0
      endif

      plast  =  delta

      sd = delta
      return
      end
