      subroutine updsd(n,ptrgt,p,pdiff,pprev,pnext,
     +                plist,pfirst,plast,pbest,blmove,delta)

      implicit none

c     ------------------------------------------------------------------
c     updsd: Updates plist switching pbest to its right position.
c     Then pbest is removed from the linked list of differences.
c     ------------------------------------------------------------------
c     Passed scalars:
c     
c     n       - problem dimension
c     pfirst  - first element in the linked list of differences
c     plast   - last  element in the linked list of differences
c     pbest   - index of moved element in the permutation
c     blmove  - index of moved element in the list of moves 
c     delta   - distance between current permutation p and ptarget
c     ------------------------------------------------------------------
      integer n,pfirst,plast,pbest,blmove,delta
c     ------------------------------------------------------------------
c     Passed arrays:
c
c     p       - permutation array
c     ptrgt   - target permutation array 
c     pdiff   - array of symetric differences
c     pprev   - pointers to previous elements in the differences linked list 
c     pnext   - pointers to next elements in the differences linked list 
c     plist   - differences linked list 
c     ------------------------------------------------------------------
      integer p(n),ptrgt(n)
      integer pdiff(n),pprev(n),pnext(n),plist(n)
c     ------------------------------------------------------------------
c     Local scalars:
c     moveto   - position to where pbest will be moved
c     temp    - temporary varyable
c     found   - indicates if element was found in the list of moves
c     fndlst  - function that finds index in the list of moves 
c     pos     - index of found element in the list of moves 
c     ------------------------------------------------------------------
      integer moveto,temp,pos,iii
      logical found, fndlst
c     ------------------------------------------------------------------
c      Remove pbest from linked list.
c     ------------------------------------------------------------------
      moveto = pdiff(pbest)

      found = fndlst(n,moveto,pos,plist,pprev,pnext,pfirst,plast)
      call rmvsd(n,pos,pprev,pnext,pfirst,plast)
      delta =  delta - 1
  
c     ------------------------------------------------------------------
c      If both switched indexes have gone to the right position, remove
c      the other element from the list.
c     ------------------------------------------------------------------

      if(p(moveto).eq.ptrgt(pbest)) then
         call rmvsd(n,blmove,pprev,pnext,pfirst,plast)
         delta =  delta - 1
      endif

c     ------------------------------------------------------------------
c      Update permutation array.
c     ------------------------------------------------------------------
      temp            = p(pbest)
      p(pbest)        = p(pdiff(pbest))
      p(pdiff(pbest)) = temp
c     ------------------------------------------------------------------
c      Update pdiff. 
c     ------------------------------------------------------------------
      
       pdiff(pbest)  = pdiff(moveto)
       pdiff(moveto)  = moveto

      return
      end






